package com.zksy.web.controller.basicData;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zksy.common.annotation.Log;
import com.zksy.common.core.controller.BaseController;
import com.zksy.common.core.domain.AjaxResult;
import com.zksy.common.enums.BusinessType;
import com.zksy.common.utils.file.ExcelUtils;
import com.zksy.system.basicData.domain.CrmEnvSupervisionViolationSupervision;
import com.zksy.system.basicData.service.CrmEnvSupervisionViolationSupervisionService;
import com.zksy.utils.DowntemplateUtil;
import com.zksy.utils.SearchUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

/**
 * 环保监管-违法督办信息Controller
 *
 * @author sy
 * @date 2024-06-04
 */
@RestController
@RequestMapping("/crmEnvSupervisionViolationSupervision")
@Api(tags = "环保监管-违法督办信息", description = "环保监管-违法督办信息desc")
public class CrmEnvSupervisionViolationSupervisionController extends BaseController{

    @Autowired
    private CrmEnvSupervisionViolationSupervisionService service;

    @GetMapping("/getById/{borrowId}")
    @ApiOperation(value = "环保监管-违法督办信息搜索getById")
    public CrmEnvSupervisionViolationSupervision getById(@PathVariable String borrowId) {
        return service.getById(borrowId);
    }

    @GetMapping("/findByPage")
    @ApiOperation(value = "环保监管-违法督办信息分页")
    public Page findByPage(long pageNum, long pageSize, String conditionJson) throws Exception {
        return service.page(new Page<>(pageNum, pageSize), SearchUtil.parseWhereSql(conditionJson));
    }

    @GetMapping("/getList")
    @ApiOperation(value = "环保监管-违法督办信息查询所有")
    public List<CrmEnvSupervisionViolationSupervision> getList(String conditionJson) throws Exception {
        return service.list(SearchUtil.parseWhereSql(conditionJson));
    }

    /**
     * 新增环保监管-违法督办信息
     */
    @PostMapping("/save")
    @ApiOperation(value = "环保监管-违法督办信息新增")
    @Log(title = "新增环保监管-违法督办信息", businessType = BusinessType.INSERT)
    public boolean save(@RequestBody CrmEnvSupervisionViolationSupervision crmEnvSupervisionViolationSupervision) {
        return service.save(crmEnvSupervisionViolationSupervision);
    }

    /**
     * 修改环保监管-违法督办信息
     */
    @PostMapping("/updateById")
    @ApiOperation(value = "环保监管-违法督办信息修改")
    @Log(title = "修改环保监管-违法督办信息", businessType = BusinessType.UPDATE)
    public boolean updateById(@RequestBody CrmEnvSupervisionViolationSupervision crmEnvSupervisionViolationSupervision) {
        return service.updateById(crmEnvSupervisionViolationSupervision);
    }

    /**
     * 导入环保监管-违法督办信息
     */
    @ApiOperation("环保监管-违法督办信息导入")
    @Log(title = "环保监管-违法督办信息", businessType = BusinessType.IMPORT)
    @PostMapping("/importData")
    public AjaxResult importData(MultipartFile file)
    {
        try {
            List<CrmEnvSupervisionViolationSupervision> crmEnvSupervisionViolationSupervisionAll = service.list();
            List<CrmEnvSupervisionViolationSupervision> list = ExcelUtils.readMultipartFile(file, CrmEnvSupervisionViolationSupervision.class,CrmEnvSupervisionViolationSupervision.class.getDeclaredFields().length - 2);
            if(crmEnvSupervisionViolationSupervisionAll != null && crmEnvSupervisionViolationSupervisionAll.size() > 0){
                //return AjaxResult.error("数据已存在，如需重新导入请清空数据");
            }
            if(list.size() > 0){
                service.saveBatch(list);
                return success("导入成功，共计："+list.size()+"条");
            }else{
                return AjaxResult.error("无数据");
            }
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导入数据失败");
        }
    }

    @ApiOperation("环保监管-违法督办信息导出")
    @Log(title = "环保监管-违法督办信息", businessType = BusinessType.EXPORT)
    @PostMapping("/exportData")
    public AjaxResult exportData(HttpServletResponse response, String conditionJson){
        try {
            List<CrmEnvSupervisionViolationSupervision> wrapperList = service.list(SearchUtil.parseWhereSql(conditionJson));
            ExcelUtils.export(response,"环保监管-违法督办信息",wrapperList,CrmEnvSupervisionViolationSupervision.class);
            return AjaxResult.success("导出数据成功");
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导出数据失败");
        }
    }

    @Log(title = "环保监管-违法督办信息", businessType = BusinessType.DELETE)
    @PostMapping("/delete")
    @ApiOperation(value = "删除环保监管-违法督办信息", notes = "删除环保监管-违法督办信息")
    public AjaxResult delete(@RequestBody List<String> ids)
    {
        return toAjax(service.removeByIds(ids));
    }

    @DeleteMapping("/deleteAll")
    @ApiOperation(value = "清除数据", notes = "清除数据")
    public AjaxResult deleteAll(){
        return service.deleteAll();
    }

    @PostMapping("/getUploadTemplate")
    @ApiOperation(value = "获取上传模板", notes = "获取上传模板")
    public void getUploadTemplate(HttpServletResponse response) throws IOException {
        DowntemplateUtil.downloadTemplate(response,"环保监管-违法督办信息模板");
    }
}

